/* WBL 13 Jan 2009 Based on tcas/test.c r1.5 $Revision: 1.7 $ */

/*WBL 22 Jan 2017 Add triangle_main.h for release kit*/
/*WBL 30 Sep 2016 Add ability to supress output */
/*WBL 22 Sep 2016 Modify for sample.awk */
/*WBL 26 Oct 2009 Modify for yue.jia@kcl.ac.uk Oct 26, 2009 at 2:21 AM data */
/*Yue Jia tri.tar.gz 5 Jan 2009 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <assert.h>
#include "triangle_main.h"

#define ntests 14
#define ninputs 3
int testcases[ntests][ninputs+1];
long long int fitnesses[ntests+1];

void readtestcases() {
  FILE *fpt1;
  int I=0;
  fpt1 = fopen("testcases_oracle.txt","r");
  if(!(fpt1)) {
    fprintf(stderr,"failed to open (r) testcases_oracle.txt\n"); exit(1);}
  assert(ninputs==3);
  while(fscanf(fpt1,"%d %d %d %d\n",
	       &testcases[I][0],&testcases[I][1],&testcases[I][2],
	       &testcases[I][3])==ninputs+1) {
    I++;
    assert(I>0 && I<=ntests);
    }
    fclose(fpt1);
    assert(I==ntests);
}

int test_(int gettri(), const char* n, const int distance){
  int i,j,ans;
  int c=0;
  for(i=0;i<ntests;i++){
    /*
    printf("%4d ",i+1);
    for(j=0;j<ninputs;j++) printf("%4d ",testcases[i][j]);
    */
    ans = gettri(testcases[i][0],testcases[i][1],testcases[i][2]);
    /*printf("=> %d %d\n",ans,testcases[i][ninputs]);*/
    if(ans != testcases[i][ninputs]) {c++; /*testfails[i]++;*/
      //exclude failed messages since sample.bat only needs final score
      //printf("id %d test %d failed\n",n,i);
    }
  }
  if(c==0 || distance>=-1) printf("id %s %d %d\n",n,(c==0)? INT_MAX:c,distance);
  return c;
}
int test(int gettri(), const char* n, const int distance){
  int i,j,ans;
  const int c = test_(gettri, n, distance);
  fitnesses[c]++;
  return c;
}
