/*WBL 23 Sep 2016 For use with supermutant version of triangle3

WBL 22 Jan 2017 was main.c r1.31 strip back to bare essentials for release kit
WBL  2 Oct 2016 add hillclimb
WBL 30 Sep 2016 add ability to enumerate small changes
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "triangle_main.h"

#define max_mutants 1000000

/*from hillclimb.c r1.42*/
#ifndef ncompares
#define ncompares 17
#endif
#ifndef stride
#define stride (ncompares+1)
#endif

/*filename format: "id " followed by 17 digits (1 to 6) per line
  up to max_mutants lines
*/
int readmutants(const char* filename, char* mutants) {
  FILE *fpt1;
  int I=0;
  fpt1 = fopen(filename,"r");
  if(!(fpt1)) {
    fprintf(stderr,"failed to open (r) `%s'\n",filename); exit(1);}
  int s;
  while((s=fscanf(fpt1,"id %s\n",&mutants[I*stride]))==1) {
    const int l = strlen(&mutants[I*stride]);
    if(l != ncompares) {
      fprintf(stderr,"Bad mutant length on reading `%s' line%d `%s' length %d!=%d\n%s\n",
	      filename,I+1,&mutants[I*stride],l,ncompares,"Lines must start id");
      exit(1);}
    {int i; for(i=0;i<ncompares;i++) {
      const char c = mutants[I*stride+i];
      if(c<'1' || c>'6'){
	fprintf(stderr,"Bad mutant char %d '%c' on reading `%s' line%d\n",
		i,c,filename,I+1);
	exit(1);}
    }}
    if(I==0) {fprintf(stderr,"Reading `%s' ",filename); fflush(stderr);}
    I++;
    assert(I>0 && I<=max_mutants);
    }
    if(s!=EOF) {
      fprintf(stderr,"Format error on reading `%s' line%d (%d)\n",filename,I+1,s);
      exit(1);
    }
    fclose(fpt1);
    fprintf(stderr,".. Read %d mutants from `%s'\n",I,filename);
    return I;
}

  /*cf Oct 23  2009 ../triangle3/triangle.c
       Oct 30  2009 reference_distance.awk 
  reference[1]= "\"<=\""; #line12
  reference[2]= "\"<=\""; #line12
  reference[3]= "\"<=\""; #line12
  reference[4]= "\"==\""; #line18
  reference[5]= "\"==\""; #line21
  reference[6]= "\"==\""; #line24
  reference[7]= "\"==\""; #line28
  reference[8]= "\"<=\""; #line29
  reference[9]= "\"<=\""; #line30
  reference[10]= "\"<=\""; #line30
  reference[11]= "\">\""; #line39
  reference[12]= "\"==\""; #line42
  reference[13]= "\">\""; #line42
  reference[14]= "\"==\""; #line45
  reference[15]= "\">\""; #line45
  reference[16]= "\"==\""; #line48
  reference[17]= "\">\""; #line48
  */
//must be an array not a char pointer http://stackoverflow.com/questions/2222775/why-cant-i-use-this-code-to-overwrite-a-string
const char base[] = "22233332226363636";

main(int argc, char* argv[]) {
#ifndef NDEBUG
  if(argc<2){
    argc=2;
    argv[1]="default.txt";
    fprintf(stderr,"No arguments given so using '%s' to ease debugging with GDB\n",
	    argv[1]);
  }
#endif
  if(argc<2) {fprintf(stderr,"no file of mutants given\n"); exit(1);}

  readtestcases();

  char* mutants      = (char*)calloc(max_mutants,stride*sizeof(char));
  const int nmutants = readmutants(argv[1],mutants);

  int i;
  for(i=0;i<nmutants;i++) {
    mutant = &mutants[stride*i];
    test(gettri,mutant,-1);
  }
  return 0;
}
